/* 
 * TiVo initialization non-architecture specific init/setup code.
 *
 * Copyright (C) 2001 TiVo Inc. All Rights Reserved.
 */

#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/string.h>
#include <asm/bootinfo.h>

static char tfrom1[] __initdata = "nfsinit=";
static char tto1[]   __initdata = " init=/devbin/nfsinit nfsroot=";
static char tfrom2[] __initdata = "nfs1";
#ifdef CONFIG_TIVO_FUSION
static char tto2[]   __initdata = " nfsroot=192.168.20.250:/Gen06/nfsroot"
                                        " xnfsinit=192.168.20.250:/Gen06/nfsroot"
                                        " init=/devbin/nfsinit sysgen=true rw";
#else
static char tto2[]   __initdata = " nfsroot=192.168.14.250:/mips/nfsroot"
                                        " xnfsinit=192.168.14.250:/mips/nfsroot"
                                        " init=/devbin/nfsinit sysgen=true rw";
#endif
static char tfrom3[] __initdata = "xnfs=";
static char tto3[]   __initdata = " nfsroot=";
static char tfrom4[] __initdata = "xnfsinit=";
static char tto4[]   __initdata = " init=/devbin/nfsinit nfsroot=";

struct tt {
	const char *from;
	const char *to;
	int replace;
};

static struct tt transtab[] __initdata = {
	{ tfrom1, tto1, 0 },
	{ tfrom2, tto2, 1 },
	{ tfrom3, tto3, 1 },
	{ tfrom4, tto4, 0 },
	{ NULL, NULL }
};

void __init tivo_generic_setup(char *cmdline, int cmdline_size)
{
	char *p, *r;
	struct tt *ptt;

	/* Command line parsing... Handle nfsinit=, etc */
	for (ptt = transtab; ptt->from; ptt++) {
		if ((r = strstr(cmdline, ptt->from)) && (r == cmdline ||
		    *(r - 1) == ' ' || *(r - 1) == '\t')) {
			char tmpbuf[cmdline_size * 2];
			char *q, *t;
			int clsize;

			strcpy(tmpbuf, ptt->to);
			p = r + strlen(ptt->from);
			q = tmpbuf + strlen(ptt->to);
			while(*p) {
				*q = *p;
				if ((*p == ' ') || (*p == '\t')) {
					p++;
					break;
				}
				p++; q++;
			}
			*q = 0;
			if (ptt->replace) {
				/* remove old string from cmdline */
				do {
					*r++ = *p;
				} while (*p++);
			}
			clsize = strlen(cmdline);
			t = tmpbuf;
			if (clsize == 0) {
				/* skip the extra space if nothing else there */
				t++;
			}
			strncat(cmdline, tmpbuf, cmdline_size - 1 - clsize);
		}
	}
}
